<?php

/* filter.php: Page for setting values and calling the XXS filter
*
    Cpyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: filter.php,v 1.18 2005/12/19 15:53:46 sailfrog Exp $
*/

function hm_filter_html ($body, $level=1) {
    $body = str_replace(array('</BODY>', '</body>'), '<br>', $body);
    $body = preg_replace("/\/\*[^*]*\*\//", '', $body);
    $tag_list = Array( true, 

            /* ONLY these tags are allowed */
            'li', 'ol', 'ul', 'b', 'i', 'strong', 'p', 'small', 'table', 'th', 'td', 'tr', 'hr', 'center', 
            'h1', 'h2', 'h3', 'h4', 'h5', 'br', 'div', 'pre', 'blockquote', 'big');
   
    $rm_tags_with_content = Array( 'script', 'style', 'applet', 
                                   'embed', 'head', 'frameset');
    $self_closing_tags =  Array( 'img', 'br', 'hr', 'input');
    $force_tag_closing = false;
    /*
        filter level values:
         1 default level, no images, no links
         2 images only
         3 links only
         4 links and images
    */
    $rm_attnames = Array(
        '/.*/' =>
        Array(
              '/target/i',
              '/href/i',
              '/src/i',
              '/^on.*/i',
              '/^dynsrc/i',
              '/^datasrc/i',
              '/^data.*/i'
              )
        );
    $add_attr_to_tag = Array();

    switch ($level) {
        case 1:
            break;
        case 2:
            $rm_attnames = Array(
                '/.*/' =>
                Array(
                      '/target/i',
                      '/^on.*/i',
                      '/href/i',
                      '/^dynsrc/i',
                      '/^datasrc/i',
                      '/^data.*/i'
                      )
                );
            array_push($tag_list, 'img');
            $add_attr_to_tag = Array();
            break;
        case 3:
            $rm_attnames = Array(
                '/.*/' =>
                Array(
                      '/target/i',
                      '/^on.*/i',
                      '/src/i',
                      '/^dynsrc/i',
                      '/^datasrc/i',
                      '/^data.*/i'
                      )
                );
            array_push($tag_list, 'a');
            $add_attr_to_tag = Array( '/^a$/i' => Array('target' => '"_blank"'));
            break;
        case 4:
            $rm_attnames = Array(
                '/.*/' =>
                Array(
                      '/target/i',
                      '/^on.*/i',
                      '/^dynsrc/i',
                      '/^datasrc/i',
                      '/^data.*/i'
                      )
                );
            array_push($tag_list, 'a', 'img');
            $add_attr_to_tag = Array( '/^a$/i' => Array('target' => '"_blank"'));
            break;
        default:
            break;
    }
    $bad_attvals = Array(
        '/.*/' =>
            Array(
	        '/.*/' =>
	          Array(
	                Array(
                          '/^([\'\"])\s*\S+\s*script\s*:*(.*)([\'\"])/i',
                          '/^([\'\"])\s*https*\s*:(.*)([\'\"])/i',
			     ),
		        Array(
                      '\\1blah:\\2\\3',
                      '\\1http:\\2\\3',
		             )
			),     
              '/^style/i' =>
                  Array(
                        Array(
                              '/expression/i',
                              '/behaviou*r/i',
                              '/binding/i',
                              '/url\(([\'\"]*)\s*https*:.*([\'\"]*)\)/i',
                              '/url\(([\'\"]*)\s*\S+script:.*([\'\"]*)\)/i'
                             ),
                        Array(
                              'idiocy',
                              'idiocy',
                              'idiocy',
                              'url(\\1http://securityfocus.com/\\2)',
                              'url(\\1http://securityfocus.com/\\2)'
                             )
                        )
              )
        );

    $trusted = sanitize($body, 
                        $tag_list, 
                        $rm_tags_with_content,
                        $self_closing_tags,
                        $force_tag_closing,
                        $rm_attnames,
                        $bad_attvals,
                        $add_attr_to_tag
                        );
    return $trusted;
}

?>
