<?php

/* download.php: page to format message parts for download
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: download.php,v 1.23 2005/06/13 18:11:55 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'download');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file, true, true, false)) {
    $config = $_SESSION['config'];
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config, 
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* send HTTP headers for this part */
header('Pragma: ');
header('Cache-Control: cache');
header("Cache-control: private");
header("Content-type: ".$hm_input['type'].'/'.$hm_input['subtype']);
if ($hm_input['type'] == 'application' && $hm_input['subtype'] == 'octet-stream') {
    header("Content-Disposition: attachment; filename=\"".
            trim($hm_input['name'])."\""); 
}
else {
    header("Content-Disposition: filename=\"".trim($hm_input['name'])."\""); 
}

if (!isset($hm_input['decode'])) {
    $decode = false;
}
else {
    $decode = $hm_input['decode'];
}

/* output message part */
hm_output_message_part ($imap_stream, $hm_input['uid'], $hm_input['part'], $decode);

/* logout of imap and exit */
hm_imap_logout($imap_stream);

exit;

?>
