<?php

/* message.php: Page for reading messages 
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: message.php,v 1.459 2006/01/12 08:20:00 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start_time = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'message');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}

/* some basic init stuff */
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;

/* check for raw message view */
if (isset($hm_input['raw'])  && $hm_input['raw'] == 1) {
    $raw = true;
}
else {
    $raw = false;
}

/* check for full header viewing status */
if (isset($hm_input['full']) && $hm_input['full'] == 'yes') {
    $full = true;
    $_SESSION['full'] = 'yes';
}
elseif (isset($hm_input['full']) && $hm_input['full'] == 'no') {
    $full = false;
    $_SESSION['full'] = false;
    unset($_SESSION['full']);
}
elseif (isset($_SESSION['full']) && $_SESSION['full'] == 'yes') {
    $full = true;    
}
else {
    $full = false;
}

/* hidden folder view setting */
if (isset($hm_input['hide_folder_preview'])) {
    if ($hm_input['hide_folder_preview'] == 1) {
        $preview_hide = true;
    }
    else {
        $preview_hide = false;
    }
}
else {
    if (isset($_SESSION['hide_folder_preview']) &&
        $_SESSION['hide_folder_preview'] == 1) {
        $preview_hide = true;
    }
    else {
        $preview_hide = false;
    }
}
$_SESSION['hide_folder_preview'] = $preview_hide;
if (isset($_SESSION['settings']['preview_position']) &&
    $_SESSION['settings']['preview_position'] == 1) {
    $preview_pos = 'bottom';
}
else {
    $preview_pos = 'top';
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* check for keep_as_new */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen info */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* check for bottom previous and next links */
if (isset($hm_input['next_normal'])) {
    $hm_input['uid'] = $hm_input['next_uid_normal'];
}
elseif (isset($hm_input['previous_normal'])) {
    $hm_input['uid'] = $hm_input['previous_uid_normal'];
}

/* adjust new message count */
if ((isset($_SESSION['next_flag']) && $hm_input['uid'] == $_SESSION['next_flag'] &&
    isset($_SESSION['next_new']) && $_SESSION['next_new'] == 1) ||
    (isset($_SESSION['prev_flag']) && $hm_input['uid'] == $_SESSION['prev_flag'] &&
    isset($_SESSION['prev_new']) && $_SESSION['prev_new'] == 1) ||
    (isset($hm_input['new']) && $hm_input['new'] == 1)) {
    if (isset($unseen[urldecode($hm_input['mailbox'])])) {
        if ($unseen[urldecode($hm_input['mailbox'])] > 0) {
            $unseen[urldecode($hm_input['mailbox'])] -= 1;
            //$_SESSION['unseen'][urldecode($hm_input['mailbox'])] -= 1;
        }
    }
}
/* clean up flags */
if (isset($_SESSION['prev_flag'])) {
    unset($_SESSION['prev_flag']);
    unset($_SESSION['prev_new']);
}
if (isset($_SESSION['next_flag'])) {
    unset($_SESSION['next_flag']);
    unset($_SESSION['next_new']);
}
if (isset($_SESSION['current_flags'])) {
    unset($_SESSION['current_flags']);
}

/* redirect message */
if (isset($hm_input['redirect'])) {
    require_once('../lib/smtp.php');
    hm_select_mailbox($imap_stream, $hm_input['mailbox']);
    hm_send_redirect($hm_input['redirect_to'], $hm_input['mailbox'], $hm_input['uid'],
                     $imap_stream, $config, $config_file, $hm_input['redirect_from']);
}

/* search for message response */
if (isset($hm_input['find_response'])) {
    if (isset($_SESSION['settings']['sent_folder'])) {
        hm_select_mailbox($imap_stream, $_SESSION['settings']['sent_folder']);
        $search = 'SEARCH HEADER in-reply-to '.
        str_replace(array('&gt;', '&lt;'), '', $hm_input['find_response']);
        $res = hm_search_mailbox($imap_stream, $search, false);
        if (strstr($res, ' ')) {
            $res = trim(substr($res, 0, strpos($res, ' ')));
        }
        else {
            $res = trim($res);
        }
        if (is_numeric($res)) {
            $hm_input['mailbox'] = $_SESSION['settings']['sent_folder'];
            $hm_input['uid'] = $res;
        }
        else {
            $_SESSION['notices'][] = $str[254];
        }
    }
}

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* check if we can use the cache */
$cache = hm_check_cache($hm_input['mailbox']);

/* get sort information */
if (!isset($hm_input['page_num'])) {
    $hm_input['page_num'] = '0';
}
if (isset($_SESSION['settings']['sort']) 
          && array_key_exists($hm_input['mailbox'], $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][$hm_input['mailbox']];
} 
else {
    $sort = 'ARRIVAL';
}
$reuse = true;
if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
    $filter = $_SESSION['sort_filter'][$hm_input['mailbox']];
}
else {
    $filter = false;
}
if ($cache && isset($_SESSION['sort_data'][$hm_input['mailbox']])) {
    $sort_info = $_SESSION['sort_data'][$hm_input['mailbox']];
}
else {
    $reuse = false;
    $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false,
                                    $filter);
}

/* process move and delete actions */
switch (true) {
    case isset($hm_input['move']):
        $action = 'move';
        break;
    case isset($hm_input['sort']):
        $action = 'sort';
        break;
    case isset($hm_input['delete']):
        $action = 'delete';
        break;
    case isset($hm_input['read']):
        $action = 'read';
        break;
    case isset($hm_input['unread']):
        $action = 'unread';
        break;
    case isset($hm_input['copy']):
        $action = 'copy';
        break;
    default:
        $action = false;
        break;
}

if ($action) {
    $dest = false;
    $action_uid = false;
    if (isset($hm_input['destination'])) {
        $dest = $hm_input['destination'];
    }
    if ($action == 'delete') {
        $action_uid = $hm_input['uid_delete'];
    }
    elseif ($action == 'move') {
        $action_uid = $hm_input['uid_move'];
    }
    if ($action_uid) {
        if ($action == 'delete' && isset($hm_input['skip_trash'])) {
            $skip = true;
        }
        else {
            $skip = false;
        }
        $result = hm_message_controls($action, $imap_stream,
                  $action_uid, $dest, false, false, $hm_input['mailbox'], 
                  1, $str[26], $skip);
    }   
    if (isset($_SESSION['thread_data'][$hm_input['mailbox']])) {
        unset($_SESSION['thread_data'][$hm_input['mailbox']]);
    }
    $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false,
                                    $filter);
}

/* bail if the message is gone */
if (!in_array($hm_input['uid'], $sort_info[2])) {
    if ($cache) {
        $sort_info = &hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox'], false);
    }
    if (!in_array($hm_input['uid'], $sort_info[2])) {
        $_SESSION['notices'][] = $str[256];
        if (isset($hm_input['search']) && $hm_input['search'] == 1) {
            $_SESSION['notices'][] = $str[216].'<br>'.$str[217];
            header("Location: ".$config['hostname'].$config['install_path'].
                "search.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
            exit;
        }
        else {
            $_SESSION['notices'][] = $str[218];
            header("Location: ".$config['hostname'].$config['install_path'].
                "mailbox.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
            exit;
        }
    }
    else {
        if ($filter) {
            if (isset($_SESSION['sort_filter'][$hm_input['mailbox']])) {
                unset($_SESSION['sort_filter'][$hm_input['mailbox']]);
                $_SESSION['notices'][] = $str[334];
            }
        }
    }
}

/* get message structure */
$structure = hm_get_struct($imap_stream, $hm_input['uid']);

/* check for drafts */
$draft = false;
if (isset($_SESSION['settings']['drafts_folder']) && urldecode($hm_input['mailbox']) ==
    $_SESSION['settings']['drafts_folder']) {
    $tmp = &hm_get_messages($hm_input['uid'], $imap_stream);
    $flags = $tmp[$hm_input['uid']][5];
    if (stristr($flags, 'draft')) {
        $draft = true;
    }
}

/* check for full message display on LARGE message parts */
$_SESSION['cutoff'] = 0;
unset($_SESSION['cutoff']);
if (isset($hm_input['big_text'])) {
    $cutoff = false;
    $pview_tag = '&amp;big_text=true';
}
else {
    $cutoff = true;
    $pview_tag = '';
}

/* get message headers */
$message_headers = hm_get_full_header($imap_stream, $hm_input['uid'], false);
$subject = $str[229];
if (isset($message_headers['subject']) && $message_headers['subject'] != '') {
    $subject = $message_headers['subject'];
}
$date = $str[231];
if (isset($_SESSION['settings']['date_string'])) {
    $date_string = $_SESSION['settings']['date_string'];
}
else {
    $date_string = 'g:i a, F j, Y';
}
if (isset($message_headers['date']) && $message_headers['date'] != '') {
    $date = date($date_string, (hm_strtotime($message_headers['date'])));
}
$from = $str[230];
if (isset($message_headers['from']) && $message_headers['from'] != '') {
    $from = stripslashes($message_headers['from']);
}
$to = $str[232];
if (isset($message_headers['to']) && $message_headers['to'] != '') {
    $to = $message_headers['to'];
}
$cc = false;
if (isset($message_headers['cc']) && $message_headers['cc'] != '') {
    $cc = $message_headers['cc'];
}
$xmailer = false;
if (isset($message_headers['x-mailer']) && $message_headers['x-mailer'] != '') {
    $xmailer = $message_headers['x-mailer'];
}
elseif (isset($message_headers['user-agent']) && $message_headers['user-agent'] != '') {
    $xmailer = $message_headers['user-agent'];
}

/* check for mailing list header */
$message_list_reply = false;
$message_list_reply_to = false;
if (isset($message_headers['list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['x-list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-mailing-list'])) {
    if (preg_match("/([^\s]+@[^\s]+)/i", $message_headers['x-mailing-list'], $matches)) {
        $message_list_reply = true;
        if (isset($matches[1])) {
            $message_list_reply_to = $matches[1]; 
        }
        else {
            $message_list_reply_to = '';
        }
    }
}

/* message display */
list($hm_input['page_num'], $message_dsp_header, $mailbox_title) =
          hm_message_header ($sort_info, $hm_input['mailbox'], $imap_stream,
                                         $hm_input['page_num'], $hm_input['id'], 
                                         $hm_input['uid'], $_SESSION['dsp_folders'], 
                                         $simple);


/* bounce notices */
if (isset($hm_input['bounce_notice'])) {
    if ($hm_input['bounce_notice'] == 'yes') {
        $_SESSION['notices'][] =  $str[223];
    }
    else {
        $_SESSION['notices'][] =  $str[224];
    }
}
/* check for missing folders */
hm_check_folders($imap_stream);

/* check for unseen message changes from other clients */
if (in_array($hm_input['mailbox'], $_SESSION['settings']['new_mail_folders'])) {
    $unread_check = hm_search_mailbox($imap_stream, 'SEARCH UNSEEN');
    if ($unread_check != '') {
        $unread_check = count(explode(' ', $unread_check));
    }
    else {
        $unread_check = 0;
    }
    $_SESSION['unseen'][$hm_input['mailbox']] = $unread_check;
    $unseen[$hm_input['mailbox']] = $unread_check;
}

/* toolbar and any status messages */
$page_data = array();
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream, $hm_input['mailbox'],
                                       $unseen, false, $str[26], false, $hm_input['uid'],
                                       true);

/* message part selection */
if (!isset($hm_input['part'])) {
    $part = 0;
    /* blah, html default option! */
    if (isset($_SESSION['settings']['html_default']) &&
        $_SESSION['settings']['html_default'] == 'true') {
        foreach ($structure as $index => $array) {
            if (isset($array['subtype']) && $array['subtype'] == 'html') {
                $part = $index;
                break;
            }
        }
    }
}
else {
    $part = $hm_input['part'];
}
if (isset($hm_input['parts'])) {
    $part_value = $hm_input['parts'];
}
else {
    $part_value = '';
}

/* main message display */

if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
$page_data['input_mailbox']  = $hm_input['mailbox'];
$page_data['input_part']     = $part;
$page_data['input_uid']      = $hm_input['uid'];
$page_data['input_page_num'] = $hm_input['page_num'];
$page_data['input_part_value'] = $part_value;
$page_data['msg_header']       = $message_dsp_header;
$page_data['lbl_keep_new']     = $str[294];
$page_data['sid'] = session_id();

/* prev/next/back links for search results */
$page_data['prev_next_search'] = false;
$page_data['prev_next_thread'] = false;

if ((isset($hm_input['search']) && $hm_input['search'] == 1) || 
    isset($_SESSION['search_info'][$hm_input['mailbox']][$hm_input['uid']])) {
    $prev_next_search = hm_create_next_previous ($imap_stream, 
                            $_SESSION['search_info'], $hm_input['mailbox'],
                            $hm_input['uid'], 'search', true, $str[257],
                            false, false, false
                        );
    $page_data['prev_next_search'] = $prev_next_search;
}
/* prev/next/back links for thread results */
if (isset($hm_input['thread']) && $hm_input['thread'] == 1) {
    $prev_next_thread = hm_create_next_previous ($imap_stream,
                            $_SESSION['thread_data'], $hm_input['mailbox'],
                            $hm_input['uid'], 'thread', false, $str[221],
                            true, false, false
                        );
    $page_data['prev_next_thread'] = $prev_next_thread;
}
$page_data['mailbox_title'] = $mailbox_title;
$page_data['filter'] =  $filter;
$page_data['filter_name'] = $str[342];

$del_range = array();
if (isset($_SESSION['prev_flag'])) {
    $del_range[] = $_SESSION['prev_flag'];
}
$del_range[] = $hm_input['uid'];
if (isset($_SESSION['next_flag'])) {
    $del_range[] = $_SESSION['next_flag'];
}

/* folder preview option */
$page_data['folder_preview'] = false;
$page_data['folder_preview_bottom'] = false;
if (isset($_SESSION['settings']['folder_preview']) &&
    $_SESSION['settings']['folder_preview'] != 'none' &&
    !$preview_hide) {
    if (isset($_SESSION['settings']['preview_position'])) {
        if ($_SESSION['settings']['preview_position'] == 1) {
            $page_data['folder_preview_bottom'] = true;
        }
        else {
            $page_data['folder_preview'] = true;
        }
    }
    else {
        $page_data['folder_preview'] = true;
    }
        if (isset($hm_input['scroll_uid'])) {
            $scroll_uid = $hm_input['scroll_uid'];
        }
        else {
            $scroll_uid = $hm_input['uid'];
        }
        $page_data['folder_preview_data'] = hm_folder_preview($imap_stream, $scroll_uid,
                          $sort_info, $hm_input['id'], $hm_input['mailbox'],
                          $hm_input['uid']);
}

$page_data['full'] = $full;
$page_data['lbl_small_headers'] = $str[30];
$page_data['lbl_full_headers'] = $str[29];
$page_data['raw'] = $raw;
$page_data['lbl_normal_view'] = $str[32];
$page_data['lbl_raw_view'] = $str[31];
$page_data['thread'] = false;

/* thread view */
if ((isset($_SESSION['config']['client_sort']) && $_SESSION['config']['client_sort'] 
    == 'false') || !isset($_SESSION['config']['client_sort'])) {
    if (isset($_SESSION['caps']) && stristr($_SESSION['caps'], 'THREAD')) {
        $page_data['thread'] = true;
        $page_data['lbl_thread_view'] = $str[33];
    }
}

$page_data['lbl_print_view'] = $str[34];
$page_data['folder_view'] = $preview_hide;

$next_previous_links = hm_create_next_previous ($imap_stream, $del_range,
                       $hm_input['mailbox'], $hm_input['uid'], 'move', false,
                       $str[0], false, false,
                              true);
$page_data['next_previous_links'] = $next_previous_links;
$page_data['folder_options'] = implode( '', hm_folder_options2($_SESSION['move_to_destination'],
                               false, $simple, false,'class="option3"'));

// build the our_id's array
$our_ids = array();
if (isset($_SESSION['profiles'])) {
    foreach ($_SESSION['profiles'] as $array) {
        if (isset($array['from_address']) && $array['from_address'] != '') {
            $our_ids[] = $array['from_address'];
        }
    }
}

/* full headers */
if ($full && !$raw) {
    $page_data['message_headers'] = $message_headers;
}
/* small headers */
elseif (!$raw) {
    $page_data['plain_from'] = $from;
    if (preg_match("/[^\s]+@[^\s]+/", $from, $matches)) {
        $from_addy = str_replace(array('&gt;', '&lt;'), '', $matches[0]);
        $from_name = trim(str_replace(array($from_addy, '"', '&gt;', '&lt;', ')',
                        '('), '', $from));
        if ($from_name == '') {
            $from_name = $from_addy;
        }
        if (!in_array($from_addy, $our_ids)) {
            $from = str_replace($from_addy, '<a title="'.$str[148].
                    '" class="font2" href="contacts.php?id='.
                    $hm_input['id'].'&amp;prep=Add&amp;prep_addy='.urlencode($from_addy).
                    '&amp;name='.urlencode($from_name).'&amp;from_message='.
                    $hm_input['uid'].'&amp;mailbox='.$hm_input['mailbox'].
                    '">'.$from_addy.'</a>', $from);
        }
    }

    $page_data['lbl_subject'] = $str[21];
    $page_data['subject'] = $subject;
    $page_data['lbl_from'] = $str[22];
    $page_data['from'] = $from;
    $page_data['lbl_date'] = $str[23];
    $page_data['date'] = $date;
    $page_data['lbl_to'] = $str[25];
    
    $val_to = $to;
    if (strlen($to) > 200) {
        $val_to = substr($to, 0, 200 + strpos(substr($to, 200), ',')).'...';
    }
    $page_data['to'] = $val_to;
    
    $page_data['lbl_cc'] = $str[87];
    $val_cc = $cc;
    if (strlen($cc) > 200) {
        $val_cc = substr($cc, 0, 200 + strpos(substr($cc, 200), ',')).'...';
    }
    $page_data['cc'] = $val_cc;
    $page_data['xmailer']= $xmailer;

}

/* reply | reply all | reply to list | forward links */
if (!$raw) {
    $page_data['lbl_reply'] = $str[35];
    $page_data['lbl_reply_all'] = $str[36];
    $page_data['lbl_forward'] = $str[37];
    $page_data['lbl_list_reply'] = $str[40];
    $page_data['lbl_part_reply'] = $str[41];
    $page_data['lbl_part_forward'] = $str[225];
    $page_data['message_list_reply'] = $message_list_reply;
    $page_data['message_list_reply_to'] = $message_list_reply_to;
    $page_data['charset'] = $str['charset'];
    
    if (isset($config['enable_bounce_option']) && $config['enable_bounce_option'] ==
        'true') {
        $page_data['cfg_enable_bounce'] = true;
        $page_data['lbl_bounce'] = $str[222];
    }
    else {
        $page_data['cfg_enable_bounce'] = false;
    }
    
    $page_data['draft'] = $draft;
    $page_data['lbl_resume_draft'] = $str[247];
    $page_data['lbl_edit_as_new'] = $str[313];
    
    if (isset($message_headers['message-id']) && isset($_SESSION['current_flags']) &&
        stristr($_SESSION['current_flags'], 'answered')) {
        $page_data['message_id'] = $message_headers['message-id'];
        $page_data['lbl_find_response'] = $str[253];
    }
    else {
        $page_data['message_id'] = false;
    }
}
    
/* prev/next/delete links */
$next_prev_del_links = hm_create_next_previous ($imap_stream, $del_range,
                       $hm_input['mailbox'], $hm_input['uid'], 'delete', false,
                       $str[4], false, false, true);
$page_data['next_prev_del_links'] = $next_prev_del_links;

if (isset($_SESSION['settings']['trash_folder']) &&
    isset($_SESSION['settings']['skip_trash']) && !isset($_SESSION['palm'])) {
    $page_data['trash'] = true;
    $page_data['lbl_skip_trash'] = $str[311];
}
else {
    $page_data['trash'] = false;
}

/* if raw message view is selected */
if ($raw) {
    $text_part = hm_get_message_part($imap_stream, $hm_input['uid'], 'raw');
    $page_data['html_text_part'] =  hm_htmlize($text_part);
}
else {
    $part_search = false;
    if (isset($hm_input['parts']) && $hm_input['parts'] != '') {
        $message_parts = explode(',', $hm_input['parts']);
    }
    elseif (isset($hm_input['view'])) {
        $message_parts = array();
        foreach ($_POST as $name => $value) {
            if (substr($name, 0, 3) == 'mp_') {
                $message_parts[] = str_replace('_', '.', substr($name, 3));
            }
        }
    }
    elseif (isset($hm_input['view_all'])) {
        $message_parts = array();
        foreach ($_POST as $name => $value) {
            if (substr($name, 0, 4) == 'hmp_') {
                $message_parts[] = str_replace('_', '.', substr($name, 4));
            }
        }
    }
    elseif ($part > 0) {
        $message_parts = array($part);
    }
    else {
        $part_search = true;
        $message_parts = array(1);
    }
    $start = true;
    $actual_parts = array();
    $displayed = array();
    $rfc_parts = array(); 
    $output_part_array = array();
    foreach ($message_parts as $val) {
        $part_details = array();
        if ($start) {
            $start = false;
        }
        if (!$part_search) {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                       $val, false, false, $cutoff);
        } else {
            $results = &hm_find_display_part($imap_stream, $structure, $hm_input['uid'],
                       false, false, false, $cutoff);
            if ($results[1] == "\n\n     ".$str[194]."\n\n") {
                if (isset($structure[1]) && $structure[1]['type'].
                    $structure[1]['subtype'] == 'texthtml' &&
                    isset($_SESSION['settings']['html_only']) &&
                    $_SESSION['settings']['html_only'] == 'true') {
                    $results = &hm_find_display_part($imap_stream, $structure,
                               $hm_input['uid'], 1, false, false, $cutoff);
                } else {
                    $results[1] = utf8_decode($results[1]);
                }
            }
        }
        $hm_input['part']= $results[0];
        $text_part = $results[1];
        $decode    = $results[2][0];
        $type      = $results[2][1];
        $subtype   = $results[2][2];
        $dsp_type  = $results[2][3];
        if (isset($results[2][5]) && $results[2][5]) {
            $name = $results[2][5];
        }
        /* setup charset mechanism */
        $charset = 'iso-8859-1';
        $code_page = array();
        if (isset($results[2][4])) {
            $charset = strtolower($results[2][4]);
            if (isset($_SESSION['charsets'][$charset])) {
                $code_page = $_SESSION['charsets'][$charset];
            }
        }
        /* check for rfc header information on nested parts */
        $value = &hm_in_multi_array($hm_input['part'], $structure, array(), true); 
        if (isset($value) && is_array($value) && isset($value[1]['subs'])) {
            $part_details['rfc_check'] = 1;
            $part_headers = hm_get_full_header($imap_stream, $hm_input['uid'], $value[0]);
            if (!isset($part_headers['subject'])) {
                $part_headers['subject'] = $str[229];
            }
            if (!isset($part_headers['from'])) {
                $part_headers['from'] = $str[230];
            }
            if (!isset($part_headers['date'])) {
                $part_headers['date'] = $str[231];
            }
            /* check for mailing list header */
            $list_reply = false;
            if (isset($part_headers['list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            elseif (isset($part_headers['x-list-post'])) {
                if (preg_match("/<mailto:([^>]+)>/i", $part_headers['x-list-post'],
                    $matches)) {
                    $list_reply = true;
                    $list_reply_to = $matches[1]; 
                }
            }
            $page_data['list_reply'] = $list_reply;
            
            /* rfc message headers */
            if (!in_array($value, $rfc_parts)) {
                $rfc_parts[] = $value;
            }
            else {
                $part_details['input_part'] = $hm_input['part'];
                $part_headers = array();
                $part_details['part_headers'] = array();
            }
            if (is_array($part_headers) && !empty($part_headers)) {
                $part_details['part_headers'] = $part_headers;
                $feilds = array ('subject', 'from', 'date');
                if (!$full || $simple) { 
                    if (!$simple) {
                        if (preg_match("/[^\s]+@[^\s]+/", $part_headers['from'],
                            $matches)) {
                            $from_addy = str_replace(array('&gt;', '&lt;'), '',
                                         $matches[0]);
                            $from_name = trim(str_replace(array($from_addy, '"', '&gt;',
                                         '&lt;', '(', ')'), '', $part_headers['from']));
                            if ($from_name == '') $from_name = $from_addy;
                            
                            $part_details['part_headers']['from'] = $part_headers['from']
                                     = str_replace($from_addy, 
                                    '<a class="font2" href="contacts.php?id='.
                                    $hm_input['id'].'&amp;prep=Add&amp;prep_addy='.
                                    $from_addy.'&amp;from_message='.$hm_input['uid'].
                                    '&amp;mailbox='.$hm_input['mailbox'].
                                    '&amp;name='.urlencode($from_name).'">'.$from_addy.
                                    '</a>',$part_headers['from']);
                        }
                    }
                    if (isset($part_headers['date'])) {
                        $part_details['part_headers']['html_date'] = 
                        date($date_string, (hm_strtotime($part_headers['date'])));
                    }
                }
                $part_details['input_part'] = $hm_input['part'];
            }
        }
        
        switch (true) {
            case substr($dsp_type, 0, 5) == 'image' &&
                 in_array($results[2][3], $message_part_types):
                $part_details['print_part'] = hm_print_image_part ($hm_input['id'],
                                     $hm_input['mailbox'], $hm_input['uid'],
                                     $hm_input['part'], $decode, 
                                     $type, $subtype, $name);
                break;
            case $dsp_type == 'texthtml':
                $part_details['print_part'] = hm_print_html_part ($text_part,
                                    $code_page, $charset,
                                    $message_headers, $hm_input['id'], $structure,
                                    $hm_input['mailbox'], $hm_input['uid']);
                break;
            case $dsp_type == 'textplain':
                $part_details['print_part'] = hm_print_text_part ($text_part,
                                    $code_page, $charset, $hm_input['id'], 
                                    $hm_input['uid'], $hm_input['part'],
                                    $hm_input['mailbox']);
                break;
            default:
                $part_details['print_part_default'] = $results[2][5].$str[352];
                break;
        }
        $actual_parts[] = $hm_input['part'];
        $displayed[] = substr($hm_input['part'], 0, strrpos($hm_input['part'], '.'));
        
        $output_part_array[] = $part_details;
    }
    
    $page_data['part_array'] = $output_part_array;
}

/* message attachments display */
if (!$raw) {
    $page_data['lbl_msg_parts'] = $str[46];
    $page_data['lbl_mime'] = $str[44];
    $page_data['lbl_description'] = $str[45];
    $page_data['lbl_size'] = $str[24];
    $page_data['lbl_view_selected'] = $str[310];
    $page_data['lbl_view_all'] = $str[350];
    $page_data['lbl_forward_selected'] = $str[351];
    
    $atag ='<a class="font2" href="message.php?uid='.$hm_input['uid'].
           '&amp;id='.$hm_input['id'].'&amp;mailbox='.urlencode($hm_input['mailbox']).
           '&amp;page_num='.$hm_input['page_num']."&amp;";
    $page_data['attachment_data'] =  hm_print_attachments($structure, $atag, 0,
                  $message_part_types, $actual_parts);
    $page_data['attachments'] = '';
    if (isset($config['enable_redirect_option']) &&
        $config['enable_redirect_option'] == 'true') {
        if (empty($our_ids)) $our_ids[0] = '';
        $page_data['cfg_enable_redirect'] = true;
        $page_data['redirect_from'] = $our_ids[0];
        $page_data['lbl_redirect'] = $str[359];
        if (isset($_SESSION['settings']['default_redirect'])) {
            $page_data['default_redirect'] = hm_htmlize(
                $_SESSION['settings']['default_redirect']);
        }
        else {
            $page_data['default_redirect'] = '';
        }
    }       
    else {
        $page_data['cfg_enable_redirect'] = false;
    }
}

/* search headers and body for email addresses */
$test_headers = array();
foreach ($message_headers as $index => $value) {
    switch (true) {
        case preg_match('/^received/', $index):
        case $index == 'message-id':
        case $index == 'resent-message-id':
        case $index == 'references':
        case $index == 'in-reply-to':
            break;
        default:
            $test_headers[] = $value;
            break;
    }
}
if (isset($part_headers)) {
    $test_part_headers = array();
    foreach ($part_headers as $index => $value) {
        switch (true) {
            case preg_match('/^received/', $index):
            case $index == 'message-id':
            case $index == 'resent-message-id':
            case $index == 'references':
            case $index == 'in-reply-to':
                break;
            default:
                $test_part_headers[] = $value;
                break;
        }
    }
    $part_string = implode(' ', $test_part_headers);
}
else {
    $part_string = '';
}
$test_string = implode(' ', $test_headers).' '.$part_string;
if (isset($dsp_type) && substr($dsp_type, 0, 4) == 'text') {
    $test_string .= ' '.$text_part;
}
if (preg_match_all("/([\.\-\_[:alnum:]]+@[\.\-\_[:alnum:]]{2,}\.[[:alnum:]]{2,})/i", 
                   $test_string, $matches)) {
    if (isset($matches[1])) {
        $get_addresses = array_unique($matches[1]);
    }
    else {
        $get_addresses = array();
    }
}

/* add to addressbook option */
/* prev+next links and folder link stored in $message_dsp_header */
$page_data['message_dsp_header'] = $message_dsp_header;
if (!empty($get_addresses) && isset($dsp_type)) {
    $page_data['add_addbook_option'] = true;
    $page_data['lbl_add'] = $str[43];
    $addy_options = '';
    foreach ($get_addresses as $addy) {
        $addy_options .= '        <option class="option3" value="'.
             hm_special_chars2($addy, $charset, $code_page)."\">". 
             hm_special_chars2($addy, $charset, $code_page).
             "</option>\n";
    }
    $page_data['address_options'] = $addy_options;
}
else {
    $page_data['add_addbook_option'] = false;
}

/* indicator for uid sort cache use */
$page_data['reuse'] = ($reuse ? 'cached' : 'fetched');
$page_data['lbl_top'] = $str[324];

if (isset($_SESSION['palm'])) {
    $page_data['palm'] = true;
}
else {
    $page_data['palm'] = false;
}
if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}
$page_data['start_time'] = $start_time;

/* close imap connection */
hm_imap_logout($imap_stream); 

/* output HTTP headers */
hm_output_http_headers();

/* output page */
if (isset($hm_input['pv'])) {
    $page_data['lbl_return_from_pv'] = $str[91];
    hm_output_page($page_data, 'print_view_template.php', $template_set);

}
else {
    if ($simple) {
        hm_output_page($page_data, 'message_template.php', 'simple');
    }
    else {
        hm_output_page($page_data, 'message_template.php', $template_set);
    }
}

?>
