<?php

/* options.php: Page for users to change personal settings
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: options.php,v 1.187 2006/01/12 15:53:38 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'options');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}

$hm_input['id'] = session_id();
$str = $_SESSION['str'];

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for keep as new setting */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen status */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);


/* profiles */
$current_count = $_SESSION['settings']['profile_count'];

/* preserve current folded state for the new page, but don't 
   write it to the settings here, thats done on the folders page */
$current_folded = false;
if (isset($_SESSION['settings']['folded'])) {
    $current_folded = $_SESSION['settings']['folded'];
    $_SESSION['settings']['folded'] = $_SESSION['default_folded'];
}

/* remove profile */
foreach ($_POST as $name => $val) {
    if (substr($name, 0, 14) == 'remove_profile') {
        $index = substr($name, 15);
        array_splice($_SESSION['profiles'], $index, 1);
        $current_count--;
        $_SESSION['settings']['profile_count'] = $current_count;
        hmw_write_settings($_SESSION['user'], $config);
        $_SESSION['notices'][] = $str[249];
        break;
    }
}
/* add profile */
if (isset($hm_input['add_profile'])) {
    $_SESSION['profiles'][] = array('sig' => '', 'from_name' => '', 'from_address' => '');
    $current_count++;
    $_SESSION['settings']['profile_count'] = $current_count;
    hmw_write_settings($_SESSION['user'], $config);
    $_SESSION['notices'][] = $str[248];
}

/* update settings */
if (isset($hm_input['update'])) {

    /* set css value */
    $_SESSION['settings']['css_file'] = $hm_input['css_selection'];

    /* font size */
    $_SESSION['settings']['font_size'] = $hm_input['font_size'];

    /* folder_list_size */
    if (isset($hm_input['folder_size'])) {
        if ($hm_input['folder_size'] > 0 && is_int($hm_input['folder_size'])) {
            $_SESSION['settings']['folder_size'] = $hm_input['folder_size'];
        }
        else {
            $_SESSION['settings']['folder_size'] = 140;
        } 
    }

    /* date format setting */
    $_SESSION['settings']['date_format'] = $hm_input['date_selection'];

    /* time format setting */
    $_SESSION['settings']['time_format'] = $hm_input['time_selection'];

    /* combine time and date */
    if ($hm_input['date_selection'] == 'r') {
        $_SESSION['settings']['date_string'] = 'r';
    }
    else {
        $_SESSION['settings']['date_string'] = $hm_input['time_selection'].' '.
                                               $hm_input['date_selection'];
    }

    /* message listing field order */
/*
    for($i=1;$i<7;$i++) {
        $_SESSION['settings']['pos_'.$i] = $_POST['pos_'.$i];
    }
*/
    /* dictionary */
    if (isset($hm_input['dictionary'])) {
        $_SESSION['settings']['dictionary'] = $hm_input['dictionary'];
    }

    /* language setting */
    $_SESSION['settings']['lang'] = $hm_input['lang_selection'];
    $str_local = hm_translate($hm_input['lang_selection'], $lang_options);
    if (!isset($_SESSION['charsets']) || empty($_SESSION['charsets'])) {
        $_SESSION['charsets'] = include('../lang/charsets.php');
    }
    foreach ($str_local as $key => $value) {
        if (is_array($value)) {
            foreach ($value as $k => $v) {
                $_SESSION['str'][$key][$k] = hm_special_chars2($v,
                $str_local['charset'], $_SESSION['charsets'][$str_local['charset']]);
            }
        }
        else {
            $_SESSION['str'][$key] = hm_special_chars2($value, $str_local['charset'], 
            $_SESSION['charsets'][$str_local['charset']]);
        }
    }
    $str = $_SESSION['str'];
    $_SESSION['str']['charset'] = 'UTF-8';
    $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    /* display settings */

    /* message per page */
    if (isset($hm_input['page_count'])) {
        if ($hm_input['page_count'] > 250) {
            $hm_input['page_count'] = 250;
        }
        $_SESSION['settings']['page_count'] = $hm_input['page_count'];
        $_SESSION['sort_data'] = array();
        unset($_SESSION['sort_data']);
    }
    else {
        $_SESSION['settings']['page_count'] = 20;
    }
    
    /* subject size */
    if (isset($hm_input['subject_size'])) {
        $_SESSION['settings']['subject_size'] = $hm_input['subject_size'];
    }
    else {
        $_SESSION['settings']['subject_size'] = 0;
    }
    /* wrap length on message view */
    if (isset($hm_input['read_wrap'])) {
        $_SESSION['settings']['read_wrap'] = $hm_input['read_wrap'];
    }
    else {
        $_SESSION['settings']['read_wrap'] = 80;
    }

    /* timezone */
    if (isset($hm_input['timezones'])) {
        $_SESSION['settings']['timezone'] = $hm_input['timezones'];
    }
    else {
        $_SESSION['settings']['timezone'] = date('Z');
    }
    if (isset($hm_input['daylight_savings']) && $hm_input['daylight_savings'] == 1) {
        $_SESSION['settings']['daylight_savings'] = 1;
    }
    else {
        $_SESSION['settings']['daylight_savings'] = 0;
    }

    /* alternate SMTP username */

    if (isset($hm_input['alt_smtpname'])) {
        $alt_smtpname = str_replace(array('"', "'"), '', $hm_input['alt_smtpname']);
        if ($alt_smtpname == '') {
            if (isset($_SESSION['settings']['alt_smtpname'])) {
                unset($_SESSION['settings']['alt_smtpname']);
            }
        } 
        else {
            $_SESSION['settings']['alt_smtpname'] = $alt_smtpname;
        }
    }

    /* "New" folder refresh setting, defaulting to 1 min refresh rate */
    if (isset($hm_input['refresh_new'])) {
        $_SESSION['settings']['refresh_new'] = $hm_input['refresh_new'];
    } 
    else {
        $_SESSION['settings']['refresh_new'] = 1;
    }

    /* folder preview on the message page */
    if (isset($hm_input['folder_preview'])) {
        if ($hm_input['folder_preview'] == 'none') {
            $_SESSION['settings']['folder_preview'] = 'none';
        }
        else {
            $_SESSION['settings']['folder_preview'] = $hm_input['folder_preview'];
        }
    }
    if (isset($hm_input['preview_position'])) {
        $_SESSION['settings']['preview_position'] = $hm_input['preview_position'];
    }
    else {
        $_SESSION['settings']['preview_position'] = 0;
    }

    /* default folder */
    if (isset($hm_input['default_on']) && $hm_input['default_on'] == 1) {
        $_SESSION['settings']['default_folder'] = $hm_input['default_folder'];
    }
    elseif (isset($_SESSION['settings']['default_folder'])) {
        unset($_SESSION['settings']['default_folder']);
    }

    /* autocreated and locked folders */
    if (!isset($config['lock_special_folders']) ||
        $config['lock_special_folders'] != 'true') {

        /* sent folder */
        if (isset($hm_input['sent_on']) && $hm_input['sent_on'] == 1) {
            $_SESSION['settings']['sent_folder'] = $hm_input['sent_folder'];
        }
        elseif (isset($_SESSION['settings']['sent_folder'])) {
            unset($_SESSION['settings']['sent_folder']);
        }

        /* trash folder */
        if (isset($hm_input['trash_on']) && $hm_input['trash_on'] == 1) {
            $_SESSION['settings']['trash_folder'] = $hm_input['trash_folder'];
        }
        elseif (isset($_SESSION['settings']['trash_folder'])) {
            unset($_SESSION['settings']['trash_folder']);
        }
    
        /* drafts folder */
        if (isset($hm_input['drafts_on']) && $hm_input['drafts_on'] == 1) {
            $_SESSION['settings']['drafts_folder'] = $hm_input['drafts_folder'];
        }
        elseif (isset($_SESSION['settings']['drafts_folder'])) {
            unset($_SESSION['settings']['drafts_folder']);
        }
    } 

    /* delete drafts on sent option */
    if (isset($hm_input['delete_draft']) && $hm_input['delete_draft'] == 1) {
        $_SESSION['settings']['delete_draft'] = 1;
    }
    elseif (isset($_SESSION['settings']['delete_draft'])) {
        unset($_SESSION['settings']['delete_draft']);
    }

    /* skip trash display */
    if (isset($hm_input['skip_trash']) && $hm_input['skip_trash'] == 1) {
        $_SESSION['settings']['skip_trash'] = 1;
    }
    elseif (isset($_SESSION['settings']['skip_trash'])) {
        unset($_SESSION['settings']['skip_trash']);
    }

    /* new page sort method */
    if (isset($hm_input['new_page_sort'])) {
        $_SESSION['settings']['new_page_sort'] = $hm_input['new_page_sort'];
    }
    else {
        $_SESSION['settings']['new_page_sort'] = 'ARRIVAL';
    }

    /* folder detail */
    if (isset($hm_input['folder_detail'])) {
        $_SESSION['settings']['folder_detail'] = $hm_input['folder_detail'];
    }
    else {
        $_SESSION['settings']['folder_detail'] = 'new';
    }

    /* folder style */
    if (isset($hm_input['folder_style'])) {
        $_SESSION['settings']['folder_style'] = $hm_input['folder_style'];
    }
    else {
        $_SESSION['settings']['folder_style'] = 'nested';
    } 

    /* start page */
    if (isset($hm_input['start_page'])) {
        $_SESSION['settings']['start_page'] = $hm_input['start_page'];
    }
    else {
        $_SESSION['settings']['start_page'] = 'mailbox.php';
    }
    
    /* update profiles */
    for ($i=0;$i<$current_count;$i++) {
        if (ini_get('magic_quotes_gpc') == 1) {
            $_SESSION['profiles'][$i]['sig'] = stripslashes($_POST['sig_'.$i]);
            $_SESSION['profiles'][$i]['from_name'] = stripslashes(str_replace(
                array('<', '>'), '', $_POST['from_name_'.$i]));
            if (isset($_POST['from_address_'.$i])) {
                $_SESSION['profiles'][$i]['from_address'] = hm_htmlize(stripslashes(
                    str_replace(array('<', '>'), '', $_POST['from_address_'.$i])));
            }
            else {
                $_SESSION['profiles'][$i]['from_address'] = '';
            } 
        }
        else {
            $_SESSION['profiles'][$i]['sig'] = $_POST['sig_'.$i];
            $_SESSION['profiles'][$i]['from_name'] = str_replace(
                array('<', '>'), '', $_POST['from_name_'.$i]);
            if (isset($_POST['from_address_'.$i])) {
                $_SESSION['profiles'][$i]['from_address'] = hm_htmlize(str_replace(
                    array('<', '>'), '', $_POST['from_address_'.$i]));
            }
            else {
                $_SESSION['profiles'][$i]['from_address'] = '';
            } 
        }
    }

    /* filter level */
    $level = 1;
    if (isset($hm_input['filter_links']) && $hm_input['filter_links'] == 1) {
        $level = 3;
    }
    if (isset($hm_input['filter_images']) && $hm_input['filter_images'] == 1) {
        if ($level > 1) {
            $level = 4;
        }
        else{
            $level = 2;
        }
    }
    $_SESSION['settings']['filter_level'] = $level;
 
    /* simple mode */
    if (isset($hm_input['simple']) && $hm_input['simple'] == 1) {
        $_SESSION['settings']['simple'] = 'true';
    }
    else {
        $_SESSION['settings']['simple'] = 'false';
    }
   /* fold all new mail folders in simple mode flag */
    if (isset($hm_input['fold_simple']) && $hm_input['fold_simple'] == 1) {
        $_SESSION['settings']['fold_simple'] = 'true';
    }
    else {
        $_SESSION['settings']['fold_simple'] = 'false';
    } 
    /* clickable http links */
    if (isset($hm_input['click_links']) && $hm_input['click_links'] == 1) {
        $_SESSION['settings']['click_links'] = 'true';
    }
    else {
        $_SESSION['settings']['click_links'] = 'false';
    }
    /* clickable email links */
    if (isset($hm_input['click_email']) && $hm_input['click_email'] == 1) {
        $_SESSION['settings']['click_email'] = 'true';
    }
    else {
        $_SESSION['settings']['click_email'] = 'false';
    }

    /* clean line wrapping */
    if (isset($hm_input['wrap_clean']) && $hm_input['wrap_clean'] == 1) {
        $_SESSION['settings']['wrap_clean'] = 'true';
    }
    else {
        $_SESSION['settings']['wrap_clean'] = 'false';
    }
    /* html mail display */
    if (isset($hm_input['html_only']) && $hm_input['html_only'] == 1) {
        $_SESSION['settings']['html_only'] = 'true';
    }
    else {
        $_SESSION['settings']['html_only'] = 'false';
    }

    /* show clock in toolbar */
    if (isset($hm_input['show_clock']) && $hm_input['show_clock'] == 1) {
        $_SESSION['settings']['show_clock'] = 'true';
    }
    else {
        $_SESSION['settings']['show_clock'] = 'false';
    }

    /* wide toolbar */
    if (isset($hm_input['wide_bar']) && $hm_input['wide_bar'] == 1) {
        $_SESSION['settings']['wide_bar'] = 'true';
    }
    else {
        $_SESSION['settings']['wide_bar'] = 'false';
    }

    /* html mail display as default */
    if (isset($hm_input['html_default']) && $hm_input['html_default'] == 1) {
        $_SESSION['settings']['html_default'] = 'true';
    }
    else {
        $_SESSION['settings']['html_default'] = 'false';
    }
    /* font family for message text */
    if (isset($hm_input['font_type'])) {
        $_SESSION['settings']['font_type'] = $hm_input['font_type'];
    }
    else {   
        $_SESSION['settings']['font_type'] = 'monospace';
    }
    /* default redirect */
    if (isset($hm_input['default_redirect'])) {
        $_SESSION['settings']['default_redirect'] = 
        str_replace(array('"',"'"), '', $hm_input['default_redirect']);
    }
    
    /* template set */
    if (isset($hm_input['template_set'])) {
        $_SESSION['settings']['template_set'] = $hm_input['template_set'];
    }

    $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');
    /* write the settings to the user's setting file */
    hmw_write_settings($_SESSION['user'], $config);
    $_SESSION['notices'][] = $str[118];
}

if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}

/* restore folded states to current */
if ($current_folded) {
    $_SESSION['settings']['folded'] = $current_folded;
}

/* check for simple option and set flag */
$simple_dsp = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple_dsp = true;
}

/* set some defaults */
$settings = $_SESSION['settings'];
if (isset($settings['page_count']) && $settings['page_count'] > 0) {
    $page_count = $settings['page_count'];
}
else {
    $page_count = 20;
}
if (isset($settings['subject_size']) && is_int($settings['subject_size'])) {
    $subject_size = $settings['subject_size'];
}
else {
    $subject_size = 0;
}

if (isset($settings['read_wrap']) && $settings['read_wrap'] > 0) {
    $read_wrap = $settings['read_wrap'];
}
else {
    $read_wrap = 80;
}
if (!isset($settings['font_size'])) {
    $settings['font_size'] = 12;
}
elseif ($settings['font_size'] < 3) {
            switch ($settings['font_size']) {
                case 0:
                    $settings['font_size'] = 11;
                case 1:
                    $settings['font_size'] = 9;
                case 2:
                    $settings['font_size'] = 12;
                default:
                    $settings['font_size'] = 11;
            }
        }
/*
$positions = array(1 => 'checkbox', 2 => 'subject', 3 => 'from', 4 => 'date', 
                   5 => 'size',     6 => 'flags');

for ($i=1;$i<7;$i++) {
    if (!isset($settings['pos_'.$i])) {
        $settings['pos_'.$i] = $positions[$i];
    }
}
*/

/* available languages */
if (!isset($settings['lang'])) {
    if (isset($_SESSION['config']['default_lang'])) {
        $settings['lang'] = $_SESSION['config']['default_lang'];
    }
    else {
        $settings['lang'] = 'en_US';
    }
}
$langs = array();
if ($dir = @opendir("../lang")) {
  while (($file = readdir($dir)) !== false) {
    if (preg_match("/\.php$/", $file) && $file != 'index.php' && 
        $file != 'lang_index.php') {
        $langs[] = str_replace('.php', '', $file);
    } 
  }  
  closedir($dir);
}
$lcount = count($langs);

/* select CSS */
if (!isset($settings['css_file'])) {
    if (isset($config['default_theme'])) {
        $settings['css_file'] = $config['default_theme'];
    }
    else {
        $settings['css_file'] = 'default.css';
    }
}
$css_files = array();
if ($dir = @opendir("../themes")) {
  while (($file = readdir($dir)) !== false) {
    if (preg_match("/\.css$/", $file) && !stristr($file, 'small') &&
        !stristr($file, 'large')) {
        $css_files[] = $file;
    } 
  }  
  closedir($dir);
}
sort($css_files);
$count = count($css_files);

/* template sets */

$templates = array();
if ($dir = @opendir("../templates")) {
    while (($file = readdir($dir)) !== false) {
        if ($file != 'simple' && $file != 'stb' && $file{0} != '.' && $file != 'CVS' && 
            substr($file, -4) != '.php') {
            $templates[] = $file;
        }
    }  
  closedir($dir);
}
sort($templates);

/* check for missing folders */
hm_check_folders($imap_stream);

/* toolbar */
$page_data = array();
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream, $hm_input['mailbox'],
                                           $unseen, false, $str[12]);

$page_data['nn4'] = isset($_SESSION['nn4_warning']);
$page_data['is_palm'] = isset($_SESSION['palm']);
$page_data['input_id'] = $hm_input['id'];
$page_data['input_mailbox'] = $hm_input['mailbox'];

// block headings
$page_data['lbl_display'] = $str[98];
$page_data['lbl_html_filter'] = $str[99];
$page_data['lbl_default_profile'] = $str[100];
$page_data['lbl_folders'] = $str[13];

# themes
$page_data['lbl_theme'] = $str[105];
$themes = array();
for ($n=0;$n<$count;$n++) {
    $themes[$css_files[$n]] = str_replace('.css', '', $css_files[$n]);
}
$page_data['current_theme'] = $settings['css_file'];
$page_data['themes'] = $themes;

/* folder list size */
$page_data['lbl_folder_size'] = 'Folder list width';
if (isset($settings['folder_size'])) {
    $page_data['folder_size'] = $settings['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}

/* template sets */
$page_data['templates'] = $templates;
if (isset($settings['template_set'])) {
    $page_data['current_template_set'] = $settings['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $page_data['current_template_set'] = $config['template_set'];
}
else {
    $page_data['current_template_set'] = 'default';
}
$page_data['lbl_template_set'] = $str[365];

/* dictionaries for spellchecking */
if (isset($config['enable_spellcheck']) && $config['enable_spellcheck'] == 'true') {
    $page_data['enable_dicts'] = true;
    $page_data['dicts'] = $dicts;
    $page_data['lbl_dicts'] = $str[382];
    $page_data['lbl_dict'] = $str[380];
    if (isset($hm_input['dictionary'])) {
        $page_data['dictionary'] = $hm_input['dictionary'];
    }
    elseif (isset($settings['dictionary'])) {
        $page_data['dictionary'] = $settings['dictionary'];
    }
    elseif (isset($dicts) && !empty($dicts)) {
        foreach ($dicts as $dict) {
            $page_data['dictionary'] = $dict;
            break;
        }
    }
    else {
        $page_data['dictionary'] = 'en';
    }
        
}
else {
    $page_data['enable_dicts'] = false;
}

/* languages */
$lanugages = array();
for ($n=0;$n<$lcount;$n++) {
    if (isset($lang_options[$langs[$n]])) $languages[$langs[$n]] = $str[$lang_options[$langs[$n]]];
}
$page_data['lbl_language'] = $str[215];
$page_data['current_language'] = $settings['lang'];
$page_data['languages'] = $languages;

/* font size */
//$sizes = array($str[279] => 0, $str[278] => 1, $str[280] => 2);
$sizes = array(8, 9, 10, 11, 12, 13, 14, 15, 16);
$font_sizes = array();
foreach ($sizes as $val) {
    $font_sizes[$val] = $val;
}
$page_data['lbl_font_size'] = $str[281];
$page_data['current_font_size'] = $settings['font_size'];
$page_data['font_sizes'] = $font_sizes;

/* time format */
$time_formats = array(
    'g:i:s a' => '12:00:00',
    'G:i:s'   => '24:00:00',
    'g:i a'   => '12:00',
    'G:i'     => '24:00',
);
$page_data['lbl_time_format'] = $str[264];
$page_data['current_time_format'] = $settings['time_format'];
$page_data['time_formats'] = $time_formats;

/* date format */
$date_formats = array('m/d/y'  => 'mm/dd/yy',     'm/d/Y'  => 'mm/dd/yyyy',
                    'm-d-y'  => 'mm-dd-yy',     'm/d/Y'  => 'mm-dd-yyyy',
                    'M j, Y' => 'mon dd, yyyy', 'M j, y' => 'mon dd, yy',
                    'M j'    => 'mon dd',       'F d, Y' => 'month dd, yyyy',
                    'F d, y' => 'month dd, yy', 'r'      => 'rfc822',
                    'd/m/Y'  => 'dd/mm/yyyy',   'd/m/y'  => 'dd/mm/yy',
                    'Y-m-d'  => 'yyyy-mm-dd',   'y-m-d'  => 'yy-mm-dd',
                    'd M Y'   => 'dd mon yyyy');
$page_data['lbl_date_format'] = $str[263];
$page_data['current_date_format'] = $settings['date_format'];
$page_data['date_formats'] = $date_formats;

/* font type */
$fonts = array('serif', 'sans-serif', 'cursive', 'fantasy', 'monospace');
$font_types = array();
foreach ($fonts as $font) {
    $font_types[$font] = $font;
}
$page_data['lbl_font_type'] = $str[107];
$page_data['current_font_type'] = (isset($settings['font_type']) ? $settings['font_type'] : 'monospace');
$page_data['font_types'] = $font_types;

/* new page refresh rate */
if (isset($config['refresh_limit']) && is_numeric($config['refresh_limit'])) {
    $times = array(0, $config['refresh_limit']);
}
else {
    $times = array(0,1,2,3,5,10,15,20,30);
}
$refresh_times = array();
foreach ($times as $value) {
    if ($value != 1) {
        $mins = $str[120];
    }
    else {
        $mins = $str[119];
    }
    $mins = $value . ' ' . $mins;
    if ($value == 0) {
        $mins = $str[106];
    }
    $refresh_times[$value] = $mins;
}
$page_data['lbl_refresh_interval'] = $str[108];
$page_data['current_refresh_time'] = (isset($settings['refresh_new']) ?
                                     $settings['refresh_new'] : 1);
$page_data['refresh_times'] = $refresh_times;

/* start page */
$start_pages = array(
    'mailbox.php'  => $str[220],
    'new.php'      => $str[10],
    'compose.php'  => $str[15],
    'options.php'  => $str[12],
    'folders.php'  => $str[13],
    'contacts.php' => $str[14],
    'search.php'   => $str[11]
);
$page_data['lbl_start_page'] = $str[219];
$page_data['current_start_page'] = (isset($settings['start_page']) ?
                                   $settings['start_page'] : 'mailbox.php');
$page_data['start_pages'] = $start_pages;

/* per page count for mailbox page */
$page_data['lbl_messages_per_page'] = $str[109];
$page_data['page_count'] = $page_count;

/* subject length max */
$page_data['lbl_subject_size'] = $str[301];
$page_data['subject_size'] = $subject_size;

/* wrap at length in chars for message page */
$page_data['lbl_read_wrap'] = $str[110];
$page_data['read_wrap'] = $read_wrap;

/* clean wrapping toggle */
$page_data['lbl_wrap_clean'] = $str[111];
$page_data['wrap_clean'] = ($settings['wrap_clean'] == 'true');

/* show html part toggle */
$page_data['lbl_html_only'] = $str[235];
$page_data['html_only'] = ($settings['html_only'] == 'true');

/* show clock toggle */
$page_data['lbl_show_clock'] = $str[284];
$page_data['show_clock'] = (isset($settings['show_clock']) && 
                           $settings['show_clock'] == 'true');

/* wide toolbar */
$page_data['lbl_wide_bar'] = $str[285];
$page_data['wide_bar'] = (isset($settings['wide_bar']) && 
                         $settings['wide_bar'] == 'true');

/* html default toggle */
$page_data['lbl_html_default'] = $str[274];
$page_data['html_default'] = ($settings['html_default'] == 'true');

/* simple mode toggle */
if (!isset($config['always_simplify']) || $config['always_simplify'] != 'true') {
    $page_data['show_simple'] =  true;
    $page_data['lbl_simple'] = $str[112];
    $page_data['simple'] = ($settings['simple'] == 'true');
}

/* fold all in simple mode */
$page_data['lbl_fold_simple'] = $str[371];
if (isset($settings['fold_simple'])) {
    $page_data['fold_simple'] = ($settings['fold_simple'] == 'true');
}
else {
    $page_data['fold_simple'] = false;
}

/* default_redirect */
if (isset($config['enable_redirect_option']) &&
    $config['enable_redirect_option'] == 'true') {
    $page_data['show_default_redirect'] = true;
    $page_data['lbl_default_redirect'] = $str[358];
    $page_data['default_redirect'] = (isset($settings['default_redirect']) ?
                                     hm_htmlize($settings['default_redirect']) : '');
}
else {
    $page_data['show_default_redirect'] = false;
}

/* HTML links filter toggle */
$page_data['lbl_filter_links'] = $str[113];
$page_data['filter_links'] = ($settings['filter_level'] == 3 ||
                              $settings['filter_level'] == 4);

/* HTML images filter toggle */
$page_data['lbl_filter_images'] = $str[114];
$page_data['filter_images'] = ($settings['filter_level'] == 2 ||
                               $settings['filter_level'] == 4);

/* TEXT clickable links toggle */
$page_data['lbl_click_links'] = $str[237];
$page_data['click_links'] = ($settings['click_links'] == 'true');

/* TEXT clickable email addresses toggle */
$page_data['lbl_click_email'] = $str[238];
$page_data['click_email'] = ($settings['click_email'] == 'true');



/* the folder options */
$folders = $_SESSION['folders'];
if (isset($settings['default_folder'])) {
    $current_default = urldecode($settings['default_folder']);
}
else {
    $current_default = 'INBOX';
}
if (isset($settings['sent_folder'])) {
    $current_sent = urldecode($settings['sent_folder']);
}
else {
    $current_sent = 'INBOX';
}
if (isset($settings['drafts_folder'])) {
    $current_drafts = urldecode($settings['drafts_folder']);
}
else {
    $current_drafts = 'INBOX';
}
if (isset($settings['trash_folder'])) {
    $current_trash = urldecode($settings['trash_folder']);
}
else {
    $current_trash = 'INBOX';
}
if (isset($config['lock_special_folders'])) {
    $page_data['lock_special_folders'] = ($config['lock_special_folders'] == 'true');
}
else {
    $page_data['lock_special_folders'] = false;
}

/* default folder */
$page_data['default_folder_set'] = isset($settings['default_folder']);
$page_data['lbl_set_default_folder'] = $str[316];
$page_data['folder_options'] = implode('', hm_folder_options2($current_default,
                                       false, $simple_dsp, false));

/* sent folder */
$page_data['sent_folder_set'] = isset($settings['sent_folder']);
$page_data['lbl_enable_sent_folder'] = $str[115];
$page_data['sent_folder_options'] = implode('', hm_folder_options2($current_sent, false,
                                            $simple_dsp, false));

/* trash folder */
$page_data['trash_folder_set'] = isset($settings['trash_folder']);
$page_data['lbl_enable_trash_folder'] = $str[116];
$page_data['trash_folder_options'] = implode('', hm_folder_options2($current_trash, false,
                                             $simple_dsp, false));

/* drafts folder */
$page_data['drafts_folder_set'] = isset($settings['drafts_folder']);
$page_data['lbl_enable_drafts_folder'] = $str[117];
$page_data['drafts_folder_options'] = implode('', hm_folder_options2($current_drafts,
                                              false, $simple_dsp, false));

/* delete draft option */
$page_data['lbl_delete_draft'] = $str[361];
$page_data['delete_draft'] = isset($settings['delete_draft']);

/* skip trash option */
$page_data['lbl_skip_trash'] = $str[312];
$page_data['skip_trash'] = isset($settings['skip_trash']);

/* new page sort method */
$page_data['show_sort_types'] = false;
if (!isset($config['client_sort']) || $config['client_sort'] != 'true') {
    $page_data['show_sort_types'] = true;
    $page_data['lbl_sort_types'] = $str[355];
    $page_data['sort_types'] = $str['sort_types'];
    if (isset($page_data['sort_type'])) {
        $page_data['sort_type'] = $settings['new_page_sort'];
    }
    else {
        $page_data['sort_type'] = 'ARRIVAL';
    }
}

/* timezone option */
$page_data['timezones'] = hm_build_timezones();
$page_data['lbl_timezones'] = $str[383];
$page_data['lbl_daylight'] = $str[384];
if (isset($settings['timezone'])) {
    $page_data['current_timezone'] = $settings['timezone'];
}
else {
    $page_data['current_timezone'] = date('Z');
    if (date('I') == 1) {
        $page_data['current_timezone'] -= 3600;
    }
}
if (isset($settings['daylight_savings'])) {
    $page_data['current_daylight'] = $settings['daylight_savings'];
}
else {
    if (date('I') == 1) {
        $page_data['current_daylight'] = true;
    }
    else {
        $page_data['current_daylight'] = false;
    }
}

/* folder detail option */
$fold_detail = array ('none' => $str[292], 'new' => $str[268], 'total' => $str[269]);
$page_data['lbl_folder_details'] = $str[270];
$page_data['folder_details'] = $fold_detail;
$page_data['folder_detail'] = $settings['folder_detail'];

/* folder style */
$fold_styles = array ('nested' => $str[266], 'flat' => $str[267]);
$page_data['lbl_folder_style'] = $str[271];
$page_data['folder_styles'] = $fold_styles;
$page_data['folder_style'] = $settings['folder_style'];

/* folder preview */
$folder_preview_opts = array(
    'none' => $str[291], 
    3 => '3 '.$str[18], 
    5 => '5 '.$str[18], 
    7 => '7 '.$str[18], 
    9 => '9 '.$str[18],
    11 => '11 '.$str[18], 
    13 => '13 '.$str[18]
);
$page_data['lbl_folder_preview'] = $str[275];
$page_data['folder_previews'] = $folder_preview_opts;
$page_data['folder_preview'] = $settings['folder_preview'];

/* folder preview location */
$fold_pos_opts = array('0' => $str[276], '1' => $str[277]);
$page_data['preview_positions'] = $fold_pos_opts;
$page_data['preview_position'] = $settings['preview_position'];

/* profiles */
if (isset($config['disable_profiles']) && $config['disable_profiles'] == 'true') {
    $use_profiles = false;
    $current_count = 1;
}
else {
    $use_profiles = true;
}

$page_data['profiles'] = array();
for ($i=0;$i<$current_count;$i++) {
    if (isset($_SESSION['profiles'])) {
        $current_profile = $_SESSION['profiles'][$i];
    }
    else {
        $current_profile = array('from_name' => '', 'from_address' => '',
                                 'sig' => '');
    }
    $current_profile['num'] = $i;
    if (!isset($current_profile['from_name']) || $current_profile['from_name'] == '') {
        $current_profile['html_from_name'] = hm_htmlize($_SESSION['user']);
    }
    else {
        $current_profile['html_from_name'] = hm_htmlize($current_profile['from_name']);
    }
    if (!isset($current_profile['sig'])) {
        $current_profile['sig'] = '';
    }
    $page_data['profiles'][] = $current_profile;
}
$page_data['lbl_default_profile'] = $str[100];
$page_data['lbl_profile'] = $str[104];
$page_data['lbl_name'] = $str[93];
$page_data['lbl_sig'] = $str[102];
$page_data['lbl_address'] = $str[101];
$page_data['lbl_update_settings'] = $str[103];
$page_data['lbl_new_profile'] = $str[250];
$page_data['lbl_remove_profile'] = $str[251];
$page_data['use_profiles'] = $use_profiles;
$page_data['lbl_top'] = $str[324];
$page_data['start_time'] = $start;

hm_imap_logout($imap_stream); 

/* output HTTP headers */
hm_output_http_headers();

/* output page */

if ($simple_dsp) {
    hm_output_page($page_data, 'options_template.php', 'simple');
}
else {
    hm_output_page($page_data, 'options_template.php', $template_set);
}

?>
